# coding:utf8
from BaseDataMaintenance.model.ots.BaseModel import BaseModel
from BaseDataMaintenance.common.Utils import *
from BaseDataMaintenance.primarykey.startSnowflake import get_guid
import json
from BaseDataMaintenance.dataSource.source import getConnect_ots
from tablestore import *

from BaseDataMaintenance.maintenance.dataflow import Dataflow_dumplicate

ots_client = getConnect_ots()

stage_priority_dict = {
    "立项阶段": "立项阶段",
    "可研阶段": "可研阶段",
    "环评阶段": "环评阶段",
    "稳评阶段": "环评阶段",
    "咨询阶段": "环评阶段",
    "造价阶段": "环评阶段",
    "设计阶段": "设计阶段",
    "勘察阶段": "设计阶段",
    "EPC总承包": "设计阶段",
    "施工图审": "施工准备",
    "施工许可": "施工准备",
    "施工准备": "施工准备",
    "施工在建": "施工在建",
    "竣工阶段": "竣工阶段"
}

data_flow = Dataflow_dumplicate(start_delete_listener=False)


class proposedBuilding_tmp(BaseModel):

    def __init__(self, _dict):

        for k, v in _dict.items():
            self.setValue(k, v, True)
        self.table_name = "proposedBuilding_tmp"
        self.dict_enterprise = {}
        self.dict_enterprise_contact = {}
        self.dict_document = {}
        self.data_flow = data_flow

    def getPrimary_keys(self):
        return ["uuid"]

    # def getFollows(self,list_group):
    #
    #
    #
    #     dict_stage = {}
    #
    #
    #     #sort
    #     list_group.sort(key=lambda x:x.get("page_time",""))
    #
    #
    #     list_follows = []
    #     #dumplicate
    #     set_stage_page_time = set()
    #     for _group in list_group:
    #         current_stage = _group.get("stage","")
    #         current_pageTime = _group.get("page_time","")
    #         if current_stage=="" or current_pageTime=="":
    #             continue
    #         _key = "%s-%s"%(str(current_stage),str(current_pageTime))
    #         if _key in set_stage_page_time:
    #             continue
    #         list_follows.append(_group)
    #         set_stage_page_time.add(_key)
    #     return list_follows

    # for _group in list_group:
    #     _stage = _group["stage"]
    #     if _stage not in dict_stage:
    #         dict_stage[_stage] = []
    #     dict_stage[_stage].append(_group)
    #
    #
    #
    # LIST_STEGES = ["施工在建","施工准备","环评阶段","设计阶段"]
    # # LIST_STEGES = ["立项","可研","环评","稳评","其他咨询服务","造价","勘察设计","施工图审查","施工许可证","施工准备","施工在建","竣工"]
    # for k,v in dict_stage.items():
    #     v.sort(key=lambda x:x.get("page_time",""),reverse=True)
    # list_follows = []
    # last_stage = ""
    # last_pageTime = ""
    # for _STAGE_i in range(len(LIST_STEGES)):
    #     _STAGE = LIST_STEGES[_STAGE_i]
    #     for _group in dict_stage.get(_STAGE,[]):
    #         current_stage = _group.get("stage","")
    #         current_pageTime = _group.get("page_time","")
    #         if last_stage=="":
    #             last_stage = current_stage
    #             last_pageTime = current_pageTime
    #         if last_stage in LIST_STEGES[:_STAGE_i]:
    #             continue
    #         if current_pageTime>last_pageTime:
    #             continue
    #         last_stage = current_stage
    #         last_pageTime = current_pageTime
    #         list_follows.append(_group)
    # list_follows.reverse()
    # return list_follows

    def getEnterprise(self, enterprise_name, columns):
        _time = time.time()
        # if enterprise_name in self.dict_enterprise:
        #     return self.dict_enterprise[enterprise_name]
        enterprise_dict = self.search(ots_client, "enterprise", [("name", str(enterprise_name))], columns)
        self.dict_enterprise[enterprise_name] = enterprise_dict
        log("search Enterprise %s takes %.2f" % (str(enterprise_name), time.time() - _time))
        return enterprise_dict

    def getEnterprise_contact(self, enterprise_name, limit=2,
                              columns=["enterprise_name", "contact_person", "phone_no"]):

        _time = time.time()
        if enterprise_name in self.dict_enterprise_contact:
            return self.dict_enterprise_contact[enterprise_name]
        _query = BoolQuery(must_queries=[TermQuery("enterprise_name", enterprise_name),
                                         TermQuery("is_mobile", 1)])

        rows, next_token, total_count, is_all_succee = ots_client.search("enterprise_contact",
                                                                         "enterprise_contact_index",
                                                                         SearchQuery(_query, sort=Sort(sorters=[
                                                                             FieldSort("score", SortOrder.DESC)]),
                                                                                     limit=limit),
                                                                         columns_to_get=ColumnsToGet(columns,
                                                                                                     ColumnReturnType.SPECIFIED))
        list_data = getRow_ots(rows)
        self.dict_enterprise_contact[enterprise_name] = list_data
        return self.dict_enterprise_contact[enterprise_name]

    def get_enterprise_contact(self, enterprise_name, contact_person, phone_no):
        _time = time.time()
        query_list = [TermQuery("enterprise_name", enterprise_name)]
        columns_to_get = ["enterprise_name", 'is_mobile']
        limit = 5
        if contact_person:
            query_list += [TermQuery("contact_person", contact_person)]
            columns_to_get += ["phone_no"]
        else:
            query_list += [TermQuery("phone_no", phone_no)]
            columns_to_get += ["contact_person"]

        _query = BoolQuery(must_queries=query_list)

        rows, next_token, total_count, is_all_succeed = ots_client.search("enterprise_contact", "enterprise_contact_index",
                                                                          SearchQuery(_query, sort=Sort(sorters=[FieldSort("score", SortOrder.DESC)]), limit=limit),
                                                                          columns_to_get=ColumnsToGet(columns_to_get, ColumnReturnType.SPECIFIED))
        list_data = getRow_ots(rows)
        is_mobile = 0
        for data in list_data:
            if contact_person:
                if phone_no and is_mobile:
                    break
                if not phone_no:
                    phone_no = data.get('phone_no', '')
                    is_mobile = int(data.get('is_mobile', 0))
            else:
                if not contact_person:
                    contact_person = data.get('contact_person', '')
                    break
        log("search enterprise_contact %s %s %s takes %.2f" % (str(enterprise_name), str(contact_person), str(phone_no), time.time() - _time))
        return [enterprise_name, contact_person, phone_no]

    def getStage(self, _stage):

        return stage_priority_dict.get(_stage)

    def addContact(self, _contacts, _type, enterprise_name):
        # add contacts from enterprise table

        enterprise_dict = self.getEnterprise(enterprise_name, ["province", "contacts", "address"])

        enterprise_contact = self.getEnterprise_contact(enterprise_name)
        _time = time.time()
        if enterprise_dict is None:
            enterprise_dict = {}
        cellphone = ""

        _count = 0
        for _contact in enterprise_contact:
            cellphone = _contact.get("phone_no", "")
            contact_name = _contact.get("contact_person", "")
            _dict_contact = {"address": enterprise_dict.get("address", ""), "cellphone": cellphone,
                             "phone": "", "company_name": enterprise_name, "contact_name": contact_name,
                             "type": _type, "id": get_guid()}
            _dict_contact = popNoneFromDict(_dict_contact)
            _count += 1
            _contacts.append(_dict_contact)
            if _count >= 2:
                break
            log("extract contact %s takes %.2f " % (enterprise_name, time.time() - _time))

    def add_contact(self, _contacts, _type, enterprise_name, address, contact_name, cellphone, phone, ):
        _dict_contact = {"address": address, "cellphone": cellphone,
                         "phone": phone, "company_name": enterprise_name, "contact_name": contact_name,
                         "type": _type, "id": 0}
        _dict_contact = popNoneFromDict(_dict_contact)
        _contacts.append(_dict_contact)

    def getContacts(self, ots_client, list_group, set_enterprise, _contacts):
        start_time = time.time()
        start_time1 = time.time()

        set_contact = set()

        # 查document，公司名、对应联系方式一次性拿出
        value_list = []
        value_contact_list = []
        role_value_stage_contact_list = []
        roles = ['tenderee', 'agency', 'win_tenderer']
        for _group in list_group:
            _docid = _group.get("docid", 0)
            if _docid in [None, '']:
                _docid = 0
            else:
                _docid = int(_docid)
            stage = _group.get("stage", '')
            if _docid <= 0:
                continue

            document_dict = self.getDocumentWithDocid(_docid, ["sub_docs_json", "tenderee", "tenderee_contact",
                                                               "tenderee_phone", "agency", "agency_contact",
                                                               "agency_phone"])
            if document_dict is not None:
                for role in roles:
                    if role in ['tenderee', 'agency']:
                        role_value = document_dict.get(role, '')
                        contact_name = document_dict.get(role + '_contact', '')
                        contact_phone = document_dict.get(role + '_phone', '')
                    else:
                        sub_docs_json = document_dict.get("sub_docs_json", '[{}]')
                        role_value = ''
                        contact_name = ''
                        contact_phone = ''
                        for sub_docs in json.loads(sub_docs_json):
                            if role_value == '':
                                role_value = sub_docs.get("win_tenderer", "")
                                contact_name = document_dict.get(role + '_manager', '')
                                contact_phone = document_dict.get(role + '_phone', '')

                    if not role_value:
                        continue
                    role_value_stage_contact_list.append([role, role_value, stage, contact_name, contact_phone])
                    value_list.append(role_value)
                    if ((contact_name == '') ^ (contact_phone == '')) and [role_value, contact_name, contact_phone] not in value_contact_list:
                        value_contact_list.append([role_value, contact_name, contact_phone])

        # print('role_value_stage_contact_list', role_value_stage_contact_list)

        # 查enterprise，一次性查出地址
        value_list = list(set(value_list))
        value_address_dict = {}
        for value in value_list:
            enterprise_dict = self.getEnterprise(value, ["address"])
            if enterprise_dict is None:
                continue
            value_address_dict[value] = enterprise_dict.get('address', '')

        # 查enterprise_contact，一次性查出 有人名无号码/有号码无人名 联系人
        value_contact_dict = {}
        # print('value_contact_list', value_contact_list)
        for i in range(len(value_contact_list)):
            role_value, name, phone = self.get_enterprise_contact(*value_contact_list[i])
            if value_contact_list[i][1]:
                value_contact_dict[role_value + name] = phone
            else:
                value_contact_dict[role_value + phone] = name

        # print('value_address_dict', value_address_dict)
        # print('role_value_stage_contact_list', role_value_stage_contact_list)

        # 生成contact
        for role, role_value, stage, contact_name, contact_phone in role_value_stage_contact_list:
            # if role in ['tenderee', 'agency']:
            address = value_address_dict.get(role_value, '')

            if contact_name and not contact_phone:
                contact_phone = value_contact_dict.get(role_value + contact_name, '')
            if not contact_name and contact_phone:
                contact_name = value_contact_dict.get(role_value + contact_phone, '')

            cellphone = ""
            phone = ""
            if isCellphone(contact_phone):
                cellphone = contact_phone
            else:
                phone = contact_phone

            if role == 'tenderee':
                real_role = '业主单位'
            elif role == 'agency':
                real_role = '代理单位'
            else:
                if stage:
                    real_role = re.sub('阶段', '', stage) + '单位'
                else:
                    real_role = '其他单位'

            self.add_contact(_contacts, real_role, role_value, address, contact_name, cellphone, phone)

        # 同公司无联系人合并至有联系人的
        delete_list = []
        for i in range(len(_contacts)):
            c1 = _contacts[i]
            if not c1.get('contact_name', '') and not c1.get('phone', '') and not c1.get('cellphone'):
                for j in range(i+1, len(_contacts)):
                    c2 = _contacts[j]
                    if c1.get('company_name', '') == c2.get('company_name', '') \
                            and c1.get('type', '') == c2.get('type', ''):
                        delete_list.append(c1)
                        break
        for c in delete_list:
            if c in _contacts:
                _contacts.remove(c)

        # 去重
        tenderee_count = 0
        list_contact = []
        index = 0
        for _c in _contacts:
            _line = "%s-%s-%s" % (_c.get("company_name", ""), _c.get("cellphone", ""), _c.get("phone", ""))
            # if _c.get("cellphone", "") == "" and _c.get("phone", "") == "":
            #     continue
            if _line not in set_contact:
                _c['id'] = index
                list_contact.append(_c)
                index += 1
                if _c.get("type", "") == "业主单位":
                    tenderee_count += 1
            set_contact.add(_line)
        log('getContacts cost: ' + str(time.time() - start_time))
        return list_contact, tenderee_count

    def getFollows(self, list_group, _contacts, set_enterprise):
        set_follow = set()
        _version_index = 0
        set_project_uuid = set()
        list_follow = []
        if len(list_group) == 0:
            return list_follow
        for _group in list_group:
            _spid = _group.get("shenpi_id")
            _docid = _group.get("docid")
            _stage = _group.get("stage")
            follow_time = _group.get("page_time")
            _docchannel = _group.get("docchannel")
            _doctitle = _group.get("doctitle")
            progress_remark = ""
            if _docid is not None and _docid == 0:
                continue
            if "is_completed" in _group or "proportion" in _group:
                continue

            if _docid is not None and _docid != "":
                document_dict = self.getDocumentWithDocid(_docid, ["status"])
                if document_dict is None or (
                        document_dict.get("status", 0) >= 401 and document_dict.get("status", 0) <= 450):
                    continue
            #     win_tenderer = ""
            #
            #     if document_dict is not None:
            #
            #         for sub_docs in json.loads(document_dict.get("sub_docs_json","[{}]")):
            #             if win_tenderer=="":
            #                 win_tenderer = sub_docs.get("win_tenderer","")
            #
            #         _status = document_dict.get("status")
            #         remain_docid = _docid
            #         if not(_status>=201 and _status<=300):
            #             remain_docid = self.data_flow.getRemainDoc(remain_docid)
            #             log("remain_docid from %s to %s"%(str(_docid),str(remain_docid)))
            #         project_flag = False
            #         if remain_docid is not None:
            #             _project = self.getProjectWithDocid(remain_docid,["zhao_biao_page_time","zhong_biao_page_time","win_tenderer","tenderee"])
            #
            #             if _project is not None:
            #                 _uuid = _project.get("uuid")
            #                 if _uuid in set_project_uuid:
            #                     continue
            #                 progress_remark = ""
            #                 if _project.get("zhao_biao_page_time") is not None:
            #                     follow_time = max(follow_time,_project.get("zhao_biao_page_time"))
            #                     progress_remark += "%s,项目处于%s的招标阶段；"%(_project.get("zhao_biao_page_time"),_stage)
            #                 if _project.get("zhong_biao_page_time") is not None:
            #                     follow_time = max(follow_time,_project.get("zhong_biao_page_time"))
            #                     progress_remark += "截止%s"%(_project.get("zhong_biao_page_time"))
            #                 if _project.get("win_tenderer") is not None:
            #                     progress_remark += "确定%s中标人为%s"%(_stage,_project.get("win_tenderer"))
            #
            #                 if _project.get("win_tenderer") is not None:
            #                     if _project.get("win_tenderer") not in set_enterprise:
            #                         self.addContact(_contacts,"%s单位"%(str(_group.get("stage","")).replace("None","").replace("阶段","")),_project.get("win_tenderer"))
            #                         set_enterprise.add(_project.get("win_tenderer"))
            #
            #                 if _project.get("tenderee") is not None:
            #                     if _project.get("tenderee") not in set_enterprise:
            #                         self.addContact(_contacts,"业主单位",_project.get("tenderee"))
            #                         set_enterprise.add(_project.get("tenderee"))
            #
            #                 project_flag = True
            #                 set_project_uuid.add(_uuid)
            #         if not project_flag:
            #             if document_dict.get("docchannel") in (101,118,119,120):
            #                 progress_remark = "截止%s,项目处于%s；"%(_group["page_time"],str(_stage))
            #                 if win_tenderer!="":
            #                     progress_remark += "确定%s中标人为%s"%(_stage,win_tenderer)
            #             else:
            #                 progress_remark = "截止%s,项目处于%s的招标阶段；"%(_group["page_time"],str(_stage))
            # else:
            #     progress_remark = "截止%s,项目处于%s；"%(_group["page_time"],str(_stage))
            #
            # _key = "%s-%s"%(_group["page_time"],str(_stage))
            # if _key in set_follow:
            #     continue
            # set_follow.add(_key)

            _version_index += 1
            _follow = {"id": get_guid(), "crtime": getCurrent_date(), "docid": _docid, "spid": _spid,
                       "mdate": "%s 00:00:00" % follow_time,
                       "docchannel": _docchannel, "doctitle": _doctitle,
                       "progress": _stage, "progress_remark": progress_remark,
                       "version": "跟进%d" % (_version_index)}

            list_follow.append(_follow)
        list_follow.sort(key=lambda x: x.get("mdate", ""))
        _version_index = 0
        for _follow in list_follow:
            _version_index += 1
            _follow["version"] = "跟进%d" % (_version_index)
        return list_follow

    def getId(self, list_docid, list_spid):

        #
        # list_should_query = []
        # for _docid in list_docid:
        #     _q = TermQuery("docids",_docid)
        #     list_should_query.append(_q)
        # for _spid in list_spid:
        #     _q = TermQuery("spids",_spid)
        #     list_should_query.append(_q)

        return get_guid()

    def getDocumentWithDocid(self, docid, columns=["page_time", "docchannel", "sub_docs_json"]):
        if docid is None or docid == "":
            return None
        # if docid in self.dict_document:
        #     return self.dict_document.get(docid)
        partitionkey = int(docid) % 500 + 1
        document_dict = self.search(ots_client, "document", [("partitionkey", partitionkey), ("docid", int(docid))],
                                    columns)
        self.dict_document[docid] = document_dict
        return document_dict

    def getProjectWithDocid(self, docid, columns):

        bool_query = BoolQuery(must_queries=[TermQuery("docids", docid)])

        rows, next_token, total_count, is_all_succeed = ots_client.search("project2", "project2_index",
                                                                          SearchQuery(bool_query, get_total_count=True,
                                                                                      limit=10),
                                                                          columns_to_get=ColumnsToGet(columns,
                                                                                                      ColumnReturnType.SPECIFIED))
        if len(rows) > 0:
            list_data = getRow_ots(rows)
            return list_data[0]
        return None

    def toDesigned_project(self, ots_client):
        if "json_list_group" not in self.getProperties() or self.json_list_group is None or self.json_list_group == "":
            return None
        list_group = json.loads(self.json_list_group)

        # 区分历史数据，历史数据中提前取了contacts
        is_history = False
        contacts = None
        if list_group[0].get('is_history') == 1:
            is_history = True
            contacts = list_group[0].get('contacts')

        is_completed = False
        for _group in list_group:
            if "page_time" not in _group or _group["page_time"] is None:
                _group["page_time"] = ""
            if _group.get("is_completed", 0) == 1:
                is_completed = True
        list_group.sort(key=lambda x: x["page_time"])

        set_contacts = set()
        list_contacts = []
        set_follows = set()
        _version_index = 1
        crtime = getCurrent_date()
        floor_space = None

        covered_area = 0.0
        project_address = ""
        begintime = ""
        endtime = ""
        project_description = ''
        project_name = ""
        high_project_name = ""
        ordinary_name = ""
        project_follow = ""

        progress = ""

        status = "1"

        update_status = "0"
        update_time = getCurrent_date("%Y-%m-%d %H:%M:%S")
        page_time = ""
        project_code = ""
        project_type = ""
        area = ""
        province = ""
        city = ""
        district = ""

        set_docid = set()
        set_spid = set()
        set_enterprise = set()

        latest_service_time = ""

        list_follows = []

        project_nature = ""
        project_investment = 0.0

        project_structure = ""
        facade_type = ""
        floors_num = 0
        elevator = 0
        engineer_cost = 0.0
        construct_install_fee = 0.0
        facade_type2 = ""
        has_steel = 0
        proportion_unit = ""

        _version_index = 0
        for _group in list_group:
            _docid = _group.get("docid")
            _spid = _group.get("shenpi_id")

            _stage = _group.get("stage")
            follow_time = _group.get("page_time")
            _docchannel = _group.get("docchannel")
            _doctitle = _group.get("doctitle")
            progress_remark = ""
            if project_address == "" and _group.get("projectAddress") is not None:
                project_address = _group.get("projectAddress", "")

            if project_nature == "" and _group.get("project_property") is not None:
                project_nature = _group.get("project_property", "")

            if project_investment == 0 and _group.get("total_invest") is not None:
                project_investment = float(_group.get("total_invest", 0))

            if project_structure == "" and _group.get("structure") is not None:
                project_structure = _group.get("structure", "")

            if floors_num == 0 and _group.get("max_floor") is not None:
                floors_num = _group.get("max_floor", 0)

            if facade_type == "" and _group.get("wall_type") is not None:
                facade_type = _group.get("wall_type", "")

            if elevator == 0 and _group.get("has_elevator") is not None:
                elevator = _group.get("has_elevator", 0)

            if engineer_cost == 0 and _group.get("engineer_cost") is not None:
                engineer_cost = float(_group.get("engineer_cost", 0))

            if construct_install_fee == 0 and _group.get("construct_install_fee") is not None:
                construct_install_fee = float(_group.get("construct_install_fee", 0))

            if facade_type2 == "" and _group.get("wall_type2") is not None:
                facade_type2 = _group.get("wall_type2", "")

            if has_steel == 0 and _group.get("has_steel") is not None:
                has_steel = _group.get("has_steel", 0)
            if proportion_unit == "" and _group.get("proportion_unit") is not None:
                proportion_unit = _group.get("proportion_unit", "")

            if _docid is not None and _docid > 0:
                set_docid.add(str(_docid))
            if _spid is not None and _spid > 0:
                set_spid.add(str(_spid))
            if floor_space is None and _group.get("floor_space") is not None:
                floor_space = _group.get("floor_space", "")
            if covered_area == 0 and _group.get("proportion") is not None:
                covered_area = float(_group.get("proportion", 0))
            if begintime == "" and _group.get("begin_time") is not None:
                begintime = _group.get("begin_time", "")
            if endtime == "" and _group.get("endtime") is not None:
                endtime = _group.get("endtime", "")
            if project_description == "":
                project_description = _group.get("projectDigest", "")
            if project_code == "":
                project_code = _group.get("project_code", "")
            if project_name == "":
                project_name = _group.get("project_name", "")
                high_project_name = project_name
                ordinary_name = project_name
            if _group.get("page_time", "") > page_time:
                page_time = _group.get("page_time", "")
            if project_type == "" and _group.get("industry") is not None:
                project_type = _group.get("industry", "")
            if area == "":
                area = _group.get("city", "")
            if province == "":
                province = _group.get("province", "")
            if city == "":
                city = _group.get("city", "")
            if district == "":
                district = _group.get("district", "")
            if _group.get("latest_service_time", "") != "" and _group.get("latest_service_time") is not None:
                latest_service_time = _group.get("latest_service_time")

            # _follow = "%s-%s"%(_group["stage"],_group["page_time"])
            # if _follow not in set_follows:
            #     list_follows.append({"id":get_guid(),"crtime":getCurrent_date(),"mdate":"%s 00:00:00"%_group["page_time"],
            #                          "progress":_group["stage"],"progress_remark":"截止%s,该项目处于%s"%(_group["page_time"],str(self.getStage(_group.get("stage","")))),
            #                          "version":"跟进%d"%(_version_index)})
            #     set_follows.add(_follow)
            #     project_follow = "跟进%d"%(_version_index)
            #     _version_index += 1

            if _docid is not None and _docid == 0:
                continue
            if "is_completed" in _group or "proportion" in _group:
                continue

            if _docid is not None and _docid != "":
                document_dict = self.getDocumentWithDocid(_docid, ["status"])
                if document_dict is None or (
                        document_dict.get("status", 0) >= 401 and document_dict.get("status", 0) <= 450):
                    continue
            _prop = str(self.getStage(_group.get("stage", "")))
            if _prop != "" and _prop != "None":
                progress = _prop

            if is_completed:
                progress = "竣工阶段"

            _version_index += 1
            _follow = {"id": get_guid(), "crtime": getCurrent_date(), "docid": _docid, "spid": _spid,
                       "mdate": "%s 00:00:00" % follow_time,
                       "docchannel": _docchannel, "doctitle": _doctitle,
                       "progress": _stage, "progress_remark": progress_remark,
                       "version": "跟进%d" % (_version_index)}

            list_follows.append(_follow)
        if page_time == "":
            page_time = update_time[:10]

        list_follows.sort(key=lambda x: x.get("mdate", ""))
        _version_index = 0
        for _follow in list_follows:
            _version_index += 1
            _follow["version"] = "跟进%d" % (_version_index)

        # list_follows = self.getFollows(list_group,legal_contacts,set_enterprise)

        legal_contacts = []
        if is_history:
            legal_contacts, tenderee_count = contacts
        else:
            legal_contacts, tenderee_count = self.getContacts(ots_client, list_group, set_enterprise, legal_contacts)

        if len(legal_contacts) == 0:
            # print('no legal_contacts')
            return None

        des_project_type = "30"
        if len(list_follows) >= 3:
            des_project_type = "10"
        elif tenderee_count >= 1:
            des_project_type = "20"

        if len(list_follows) == 0:
            return None
        # get the key,if exists then search else generate
        id = self.getId(list(set_docid), list(set_spid))
        partitionkey = id % 200 + 1

        if project_type == "":
            project_type = "其他"
        project_dict = {"partitionkey": partitionkey, "id": id,
                        "crtime": crtime, "floor_space": floor_space, "project_address": project_address,
                        "begintime": begintime, "endtime": endtime, "project_description": project_description,
                        "project_name": project_name, "ordinary_name": ordinary_name,
                        "high_project_name": high_project_name,
                        "project_follow": project_follow, "page_time": page_time, "progress": progress,
                        "contacts": json.dumps(legal_contacts, ensure_ascii=False),
                        "follows": json.dumps(list_follows, ensure_ascii=False),
                        "follow_number": len(list_follows),
                        "docids": ",".join(list(set_docid)), "spids": ",".join(list(set_spid)),
                        "des_project_type": des_project_type, "status": status, "covered_area": covered_area,
                        "update_status": update_status, "update_time": update_time, "project_code": project_code,
                        "project_type": project_type, "area": area, "latest_service_time": latest_service_time,
                        "full_text": "%s%s" % (str(project_name), str(project_description)),
                        "json_list_group": self.json_list_group,
                        "province": province, "city": city, "district": district,
                        "project_follow": "跟进%d" % len(list_follows),
                        "project_nature": project_nature,

                        "project_investment": project_investment,
                        "project_structure": project_structure,
                        "facade_type": facade_type,
                        "floors_num": floors_num,
                        "elevator": elevator,
                        "engineer_cost": engineer_cost,
                        "construct_install_fee": construct_install_fee,
                        "facade_type2": facade_type2,
                        "has_steel": has_steel,
                        "proportion_unit": proportion_unit

                        }
        return project_dict


if __name__ == "__main__":
    s = '''
[{"docid": 0, "shenpi_id": 0, "type_id": 0, "page_time": "2001-04-02", "province": null, "city": "", "district": "", "tenderee": "全国勘察设计注册工程师管理委员会", "tenderee_contact": "", "tenderee_phone": "", "agency": "", "project_code": null, "project_name": "师制度总体框架及实施规划及全国", "doctitle": "关于发布《勘察设计注册工程师制度总体框架及实施规划》及《全国勘察设计注册工程师管理委员会组成人员名单》的通知", "docchannel": "106", "stage": "勘察阶段", "proportion": null, "projectDigest": "工程内容：各类建设工程的岩土工程。专用分类：1，专用分类：土木，执业范围：水利工程，涵盖工程内容：水坝、灌渠、河道整治等。专用分类：1，专用分类：土木，执业范围：港口与航道工程，涵盖工程内容：码头、航道、防波堤、船闸等", "projectAddress": null, "begin_time": "", "end_time": "", "project_name_refind": "师制度总体框架及实施规划及全国", "industry": "交通", "location": null, "service_time": "", "service_days": "0", "project2_uuid": null, "nlp_enterprise": "", "nlp_enterprise_attachment": "", "has_steel": 0, "has_elevator": 0, "project_property": "新建", "total_invest": 0.0, "construct_install_fee": 0.0, "engineer_cost": 0.0, "max_floor": null, "structure": null, "wall_type": null, "wall_type2": null, "main": 1, "new_enough": 1, "follow_enough": 1, "area": null, "show_name_refind": "师制度总体框架及实施规划及全国", "proportion_unit": null, "is_history": 1, "contacts": [[{"address": "", "cellphone": "", "phone": "", "company_name": "全国勘察设计注册工程师管理委员会", "contact_name": "", "type": "业主单位", "id": 0}], 1]}, {"docid": 46529764, "shenpi_id": null, "type_id": "46529764", "stage": "勘察阶段", "page_time": "2001-04-02", "location": null, "phase": null, "section": null, "new_enough": 0, "follow_enough": 1}]
    '''
    print(json.loads(s))
    a = proposedBuilding_tmp({"json_list_group": s})
    _project_dict = a.toDesigned_project(ots_client)
    # start_time = time.time()
    # _project_dict = a.toDesigned_project(ots_client)
    print(json.dumps(_project_dict, ensure_ascii=False))
    # print(time.time()-start_time)
    # from BaseDataMaintenance.model.ots.designed_project import designed_project
    # _time = time.time()
    # if _project_dict is not None:
    #     #更新数据
    #     # log("project_dict:"+json.dumps(_project_dict))
    #     _designed_project = designed_project(_project_dict)
    #     _designed_project.update_project(ots_client)
    #     print("updated")
